%
% SOR
%
clear all;
close all;

n = 32;
tol = 1e-4;
IterMax = 200;

H = hilb(n);
xtrue = ones(n,1);
b = H*xtrue;
bnorm = norm(b);

x0 = zeros(n,1);

% SOR iteration
Omega = [1.0:0.05:1.95];
for k_omega = 1 : length(Omega)
    x = x0;
    omega = Omega(k_omega);
    [x,iter,relres,flag] = SOR(H,b,x,tol,omega,IterMax);
    Iter(k_omega) = iter;
    fprintf('omega=%f, Iter=%d, relres=%.4e\n', omega, iter, relres);
end
[itermin,idx] = min(Iter);
fprintf('ŲΪ %.2f, ӦĵΪ %d\n',Omega(idx),itermin);

% plot the result
plot(Omega,Iter,'o-');
xlabel('\omega'); ylabel('iteration number');
title('SOR with different \omega');
%%%%% ========== End of the main program ===========================

% SOR iteration
function [x,iter,relres,flag] = SOR(A,b,x,tol,omega,IterMax)
bnorm = norm(b);
n = length(x);
for k = 1 : IterMax
    for i = 1 : n
        x(i) = (1-omega)*x(i) ...
            + omega/A(i,i)*( b(i) - A(i,1:i-1)*x(1:i-1) ...
            - A(i,i+1:n)*x(i+1:n) );
    end
    % D = diag(diag(A)); L = D - tril(A); U = D - triu(A);
    % x = (D-omega*L)\(((1-omega*D)+omega*U)*x + omega*b);
    relres = norm(b-A*x)/bnorm;
    if relres < tol
        iter = k; flag = 1; return
    end
end
iter = k; flag = 0;
end
 

